
stages:
  - build
  - fuzz

include:
  - template: API-Fuzzing.gitlab-ci.yml

variables:
  SELENIUM_IMAGE: registry.gitlab.com/gitlab-org/security-products/demos/api-fuzzing/auth-token-selenium/selenium-server

# Only build the selenium-server when the files
# have changed. This reduces CI minutes needed.
build_server:
  stage: build
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  only:
    changes:
      - selenium-server/**
  script:
  - mkdir -p $HOME/.docker
  - cd selenium-server
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  - docker build -t $SELENIUM_IMAGE .
  - docker push $SELENIUM_IMAGE

# DAST_API uses a recent Alpine OS with
# A modern Python3 runtime installed
# A before_script is used to install any dependencies
apifuzzer_fuzz:
  services:
  - name: $SELENIUM_IMAGE
    alias: selenium
  - name: registry.gitlab.com/gitlab-org/security-products/demos/api-dast/openapi-example/target-flask:latest
    alias: target
  variables:
    # Endpoint to scan
    FUZZAPI_TARGET_URL: http://target:7777
    # OpenAPI spec for target API
    FUZZAPI_OPENAPI: https://gitlab.com/gitlab-org/security-products/demos/api-dast/openapi-example/-/raw/main/rest_target_openapi.json
    # Overrides file produced by overrides_cmd
    FUZZAPI_OVERRIDES_FILE: overrides.json
    # Command from your repository to run
    FUZZAPI_OVERRIDES_CMD: ./overrides_cmd.py
    # How often to run our overrides_cmd in seconds
    FUZZAPI_OVERRIDES_INTERVAL: 300
  before_script:
  # Install any dependencies
  - python -m pip install -r overrides_cmd_requirements.txt
  # Make sure overrides_cmd.py is executable
  - chmod a+rx overrides_cmd.py
  # Make sure an overrides file exists on disk
  - echo {} > $FUZZAPI_OVERRIDES_FILE

# end
